/*
 * @Copyright 2010, MechSoft 
 * MechSoft, Mechanical and Software Solutions 
 * 
 * Licensed under the Apache License, Version 2.0 (the 
 * "License"); you may not use this file except in compliance 
 * with the License. You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.extjs.example;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.defne.server.json.JsonServiceMessage;
import org.defne.service.Message;
import org.defne.service.MessageFactory;

public class SurveryAdaptor extends JsonServiceMessage
{
    private static final long serialVersionUID = 1L;

    private Survey survey;

    @Override
    @SuppressWarnings("unchecked")
    public Object fromOutputMessage(Message message)
    {
        Object result = null;
        
        if(getMethod().equals(ISurveyService.AddOperation.OPERATION_NAME))
        {
            Map<String, String> map = new HashMap<String, String>();
            map.put("MESSAGE", message.getMessageParameter(String.class,ISurveyService.AddOperation.OUTPUT.MESSAGE));
            
            result = map;
        }
        else if(getMethod().equals(ISurveyService.ListOperation.OPERATION_NAME))
        {
            Map<String, List<Survey>> surveys = new HashMap<String, List<Survey>>();
            surveys.put("surveys", message.getMessageParameter(List.class, ISurveyService.ListOperation.OUTPUT.LIST));
            
            result = surveys;
        }
        
        return result;
    }

    @Override
    public Message toInputMessage()
    {
        Message message = MessageFactory.newMessage(getService(), getMethod());
        
        if(getMethod().equals(ISurveyService.AddOperation.OPERATION_NAME))
        {
            message.putMessageParameter(ISurveyService.AddOperation.INPUT.SURVEY, this.survey);   
        }
        else if(getMethod().equals(ISurveyService.ListOperation.OPERATION_NAME))
        {
            //Do nothing
        }
        
        return message;
    }
    
    
}
